<?php
class cMsg
{
	// This class handles a message comming from a previous page (session variable 'pagedialog')
	// The message is displayed thanks to a jquery function from *_page_header.
	// While the session variable is destroyed after display, the properties of this class remains accessible
	public $text; // '' means nothing (no display)
	public $fulltext;
	public $type; // i=info, e=error, w=warning, o=ok (default)
	public $items; // affected items
	function __construct()
	{
		if ( !empty($_SESSION['pagedialog']) ) $this->FromString($_SESSION['pagedialog']);
	}
	public function Clear()
	{
		$_SESSION['pagedialog']=null;
	}
	public function FromString($arr)
	{
		if ( is_string($arr) ) $arr=explode('|',$arr);
		if ( is_array($arr) )
		{
			if ( isset($arr[0]) ) $this->type = strtolower(substr($arr[0],0,1));
			if ( isset($arr[1]) ) $this->fulltext = str_replace('"','',$arr[1]);
			if ( isset($arr[2]) ) $this->items = (int)$arr[2];
			if ( $this->items>1 ) $this->fulltext .= ' ('.$this->items.')';
			$this->text = $this->fulltext;
			if ( strlen($this->text)>64 ) $this->text = substr($this->text,0,60).'...';
		}
		return $this->text;
	}
}