<?php

// QuickTalk 3.0 build:20120924

// -----------------
// Connexion config
// -----------------
require_once 'config/config.php';
if ( isset($qtg_install) && !empty($qtg_install) ) { define('QT','qtg'.substr($qtg_install,-1)); } else { define('QT','qtg'); }

// -----------------
// Settings config
// -----------------
require_once 'config/config_display.php';
if ( isset($qtg_formatdate) ) { $_SESSION[QT]['formatdate']=$qtg_formatdate; } else { $_SESSION[QT]['formatdate']='j-M-Y'; }
if ( isset($qtg_formattime) ) { $_SESSION[QT]['formattime']=$qtg_formattime; } else { $_SESSION[QT]['formattime']='G:i'; }
if ( !isset($_SESSION[QT]['language']) ) $_SESSION[QT]['language']=$qtg_language;
if ( !isset($qtg_type) ) $qtg_type='1';

require_once 'config/config_stop.php';
require_once 'config/config_map.php';

  // special demo 
  if (isset($_SESSION['qtg_skin'])) $qtg_skin = $_SESSION['qtg_skin'];

if ( substr($qtg_skin,0,5)!='skin/' ) $qtg_skin = 'skin/'.$qtg_skin;

// -----------------
// System constants (this CANNOT be changed by webmasters)
// -----------------
define('TABMESSAGE', $qtg_prefix.'qtgmessage');
define('QTGVERSION', '3.0 build:20120924');
define('QSEL', ' selected="selected"');
define('QCHE', ' checked="checked"');
define('N', "\n");
define('START', 1);
define('END', -1);
define('JQUERY_OFF', 'bin/jquery.min.js'); // jQuery resource when offline. This will be used if CDN (defined here after) is not possible.
define('JQUERYUI_OFF', 'bin/jquery-ui.min.js');
define('JQUERYUI_CSS_OFF', 'bin/css/jquery-ui/themes/base/jquery-ui.css');

// -----------------
// Function constants (this can be changed by webmasters)
// -----------------
define('QTG_OB_GZ', null); //'ob_gzhandler'); // Allow serving compressed pages. Use NULL if zlib extension is not available on your server (or if you want to disable compression)
define('QT_SHOW_CONTRAST',true); // Show contrast button in upper right corner
define('QT_MENUSEPARATOR', ' | '); // Menu separator is used in the footer (don't forget spaces).
define('QT_MAILSEPARATOR', '&nbsp;'); // In the message display, when email is allowed, use this separator between the name and the email icon. Use space (or <br/> to get the icon on the next line)
define('QT_CONVERT_AMP', FALSE); // Convert & to &amp; before saving in the db. TRUE will make impossible to insert symbols or special characters (like &#nnnn;)
define('QT_NOTIFYAFTER', 50); // Monthly notification. One notification is send when the (n)th messages is recieved. No message will be send if less than n messages are inserted during the month.

define('QT_SMARTCUT', 4);
// Smartcut is a tolerance value (0-9) while truncating long messages.
// Value 0 will truncate at the exact specified length.
// Value N>0 will truncate with following advantages:
// * truncate can preverse up to N characters if the total length is within this tolerance.
// * truncate will take place after the characters ,;:.)]}!? when these characters are just on the truncate position.
// Ex: If you decide to tuncate message after 200 characters, with smartcut of 4;
//     the function will try to preserve the last word or the last punctuation character, and
//     the total length can be 204 characters maximum.

define('QTG_URLREWRITE',false);
// URL rewriting (for expert only):
// Rewriting url requires that your server is configured with following rule for the application folder: RewriteRule ^(.+)\.html(.*) qtg_$1.php$2 [L]
// This can NOT be activated if you application folder contains html pages (they will not be accessible anymore when urlrewriting is acticated)

// -----------------
// JQUERY (this can be changed by webmaster)
// -----------------
// Content Delivery Network for jQuery and jQuery-UI. Using a CDN will increase performances.
// Possible CDN are: Google, Microsoft, jQuery-Media-Temple.
// You can also decide to use your local copy (in the bin/ directory) to avoid using a CDN.

define('JQUERY_CDN', 'https://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js');
// define('JQUERY_CDN', 'http://ajax.aspnetcdn.com/ajax/jquery/jquery-1.7.2.min.js');
// define('JQUERY_CDN', 'http://code.jquery.com/jquery-1.7.2.min.js');
// define('JQUERY_CDN', 'bin/jquery.min.js');

define('JQUERYUI_CDN', 'https://ajax.googleapis.com/ajax/libs/jqueryui/1.8.21/jquery-ui.min.js');
// define('JQUERYUI_CDN', 'http://ajax.aspnetcdn.com/ajax/jquery.ui/1.8.21/jquery-ui.min.js');
// define('JQUERYUI_CDN', 'http://code.jquery.com/ui/1.8.21/jquery-ui.min.js');
// define('JQUERYUI_CDN', 'bin/jquery-ui.min.js');

define('JQUERYUI_CSS_CDN', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.21/themes/base/jquery-ui.css');
// define('JQUERYUI_CSS_CDN', 'http://ajax.aspnetcdn.com/ajax/jquery.ui/1.8.21/themes/base/jquery-ui.css');
// define('JQUERYUI_CSS_CDN', 'http://code.jquery.com/ui/1.8.21/themes/base/jquery-ui.css');
// define('JQUERYUI_CSS_CDN', 'bin/css/jquery-ui/themes/base/jquery-ui.css');

// -----------------
// Classes and functions
// -----------------
if ( !ob_start(QTG_OB_GZ) ) ob_start();
require_once 'bin/qt_lib_html.php';
require_once 'bin/qt_lib_db.php';
require_once 'bin/qt_lib_txt.php';
require_once 'bin/qtg_class_post.php';
require_once 'bin/qtg_fn_base.php';

// CHECK SETTING

foreach(array('qtg_dbsystem','qtg_host','qtg_database','qtg_prefix','qtg_port','qtg_dsn','qtg_user','qtg_pwd','qtg_user_2','qtg_pwd_2') as $Variable)
{
if ( !isset($$Variable) ) echo $Variable.' not defined check the file config/config.php...';
}
if ( empty($qtg_dbsystem) ) die ('wrong qtg_dbsystem in file config/config.php');
if ( !QTisbetween($qtg_page_size,1,100) )   { echo 'posts_per_page invalid (1-100)'; $qtg_page_size=10; }
if ( !isset($qtg_menulang) ) $qtg_menulang=false;

// LANGUAGE if required (by coockies or by the menu)

$str=GetIso($_SESSION[QT]['language']);
if ( isset($_COOKIE[QT.'_cooklang']) ) $str=substr($_COOKIE[QT.'_cooklang'],0,2);
if ( isset($_GET['lx']) ) $str=substr($_GET['lx'],0,2);
if ( $str!=GetIso($_SESSION[QT]['language']) && !empty($str) )
{
  require_once 'bin/qtg_lang.php';
  if ( array_key_exists($str,$arrLang) )
  {
    $_SESSION[QT]['language'] = $arrLang[$str][2];
    if ( isset($_COOKIE[QT.'_cooklang']) ) setcookie(QT.'_cooklang', $str, time()+60*60*24*100, '/');
  }
  else
  {
    $error = 'Wrong iso code language';
  }
}

// Contrast check

if ( QT_SHOW_CONTRAST )
{
	if ( !isset($_SESSION['qtg_maincss']) ) $_SESSION['qtg_maincss']='maincss';
	if ( isset($_GET['css']) && ($_GET['css']=='maincss' || $_GET['css']=='contrast')  ) $_SESSION['qtg_maincss']=$_GET['css'];
}

// ----------------
// INITIALIASE Classes and Variable
// ----------------

if ( $qtg_dbsystem=='file' )
{
  require_once 'bin/qtg_class_dt.php';
  $oDB = new cDT($qtg_host);
}
else
{
  $oDB = new cDB($qtg_dbsystem,$qtg_host,$qtg_database,$qtg_user,$qtg_pwd,$qtg_port,$qtg_dsn);
}
if ( !empty($oDB->error) ) die ('<p><font color="red">Connection with database failed.<br/>Please contact the webmaster for further information.</font></p><p>The webmaster must check that server is up and running, and that the settings in the config file are correct for the database.</p>');

// if using class DT (data text)

$error = ''; // Required when server uses register_global_on
include GetLang().'qtg_main.php';
$qtg_bbctags = array('B'=>$qtg_bbc_bold,'I'=>$qtg_bbc_italic,'U'=>$qtg_bbc_underline,'A'=>$qtg_bbc_url,'S'=>$qtg_bbc_smiley); // allowed tags
$qtg_back='<div class="backbutton"><span class="backbutton"><a id="exiturl" class="backbutton" href="'.Href().'">'.$L['Return'.$qtg_type].'</a></span></div>';

// ----------------
// Default HTML settings
// ----------------
$oHtml = new cHtml();
$oHtml->dtd = QTG_HTML_DTD;
$oHtml->html = '<html xmlns="http://www.w3.org/1999/xhtml" dir="'.QTG_HTML_DIR.'" xml:lang="'.QTG_HTML_LANG.'" lang="'.QTG_HTML_LANG.'">';
$oHtml->title = $qtg_title;
$oHtml->metas['charset'] = '<meta charset="'.QTG_HTML_CHAR.'" />';
$oHtml->metas['description'] = '<meta name="description" content="QTG QuickTalk Guestbook" />';
$oHtml->metas['keywords'] = '<meta name="keywords" content="QTG,Guestbook,qt-cute,OpenSource" />';
$oHtml->metas['author'] = '<meta name="author" content="qt-cute.org" />';
$oHtml->links['icon'] = '<link rel="shortcut icon" href="'.$qtg_skin.'/qtg_icon.ico" />';
$oHtml->links['css'] = '<link rel="stylesheet" type="text/css" href="'.$qtg_skin.'/qtg.css" />';
$oHtml->scripts['base'] = '<script type="text/javascript" src="bin/qtg_base.js"></script>';

$arrExtData = array(); // Can be used by extensions
$arrCss = array();
$strLangMenu = '';
$bAdm = false;